#!/usr/bin/perl

use Log;

use integer;

package AliasesDB;

my $init = 0;
my %aliaslist;

sub addAlias {

    my $user = $_[0]; shift;
    my $tree = $_[0]; shift;
    my $nick = $_[0]; shift;
    my $aka = join (';', @_);

    open (ALIAS, ">>./trees/$tree/aliases.db");

    print ALIAS "$nick|$aka\n";

    close (ALIAS);

    Log::log ($user, $tree, "Set alias for $nick to $aka");

    return "";
}



sub initialise {

    $_tree = $_[0];

    open (ALIAS, "<./trees/$_tree/aliases.db");

    while (<ALIAS>) {
        chomp;

        (my $n, my $aka) = split (/\|/);

        $aliaslist{$n} = $aka;
    }

    close (ALIAS);

    $init = 1;
}


sub replaceAlias {

    my $user = $_[0]; shift;
    my $tree = $_[0]; shift;
    my $nick = $_[0]; shift;
    my $aka = join (';', @_);

    my $set = 0;

    open (ALIAS, "<./trees/$tree/aliases.db");
    open (NEWALIAS, ">./trees/$tree/aliases.tmp.db");

    PERSON: while (<ALIAS>) {
        ($n) = split (/\|/);
        if (!$set && $n eq $nick) {
            $set = 1;
            if ($aka =~ /\w+/) {
                print NEWALIAS "$nick|$aka\n";
            }
            next PERSON;
        } else {
            print NEWALIAS $_;
        }
    }

    if (!$set && $aka =~ /\w+/) {
        print NEWALIAS "$nick|$aka\n";
    }

    close (NEWALIAS);
    close (ALIAS);

    unlink "./trees/$tree/aliases.db";
    rename "./trees/$tree/aliases.tmp.db", "./trees/$tree/aliases.db";

    Log::log ($user, $tree, "Replaced aliases for $nick to $aka");
}


sub aliases {

    my $user = $_[0];
    my $tree = $_[1];
    my $nick = $_[2];

    if (! $init) {
        initialise ($tree);
    }

    my $aka = $aliaslist{$nick};

    return split (/\;/, $aka);
}


sub deleteAlias {

    my $_user=$_[0];
    my $_tree=$_[1];
    my $_key=$_[2];

    open (ALIAS, "<./trees/$_tree/aliases.db");
    open (NEWALIAS, ">./trees/$_tree/aliases.tmp.db");
    while (<ALIAS>) {
        (my $k) = split (/\|/);
        if ($k ne $_key) {
            print NEWALIAS "$_";
        }
    }
    close (NEWALIAS);
    close (ALIAS);

    unlink "./trees/$_tree/aliases.db";
    rename "./trees/$_tree/aliases.tmp.db", "./trees/$_tree/aliases.db";

    if ($init) {
        delete $aliaslist{$_key};
    }

    Log::log ($_user, $_tree, "Removed aliases for $_key");
}

1
