#!/usr/bin/perl

package FTUtility;

use Colour;
use TreesDB;

my $scriptsin=0;

sub navScripts {

    print <<EOF
<SCRIPT LANGUAGE=JAVASCRIPT>
function opensearchwin() {
          var options = "width=" + 400 + ",height=" + 250 + ",";
          options += "resizable=yes,scrollbars=yes,status=yes,";
          options += "menubar=no,toolbar=no,location=no,directories=no";
          var newWin = window.open('searchperson.pl?tree=$_tree&user=$_user&familyname=$_familyname&nolinks=Y', 'newWin', options);
          newWin.focus();
        }
</SCRIPT>
EOF
;

    $scriptsin = 1;
}

sub navPanel {
    my $module=$_[0];
    my $_user=$_[1];
    my $_tree=$_[2];
    my $treeset=($_tree =~ /\w+/);
    my $_familyname=$_[3];

    if (! $scriptsin) {
        navScripts;
    }

    my $editmode = Security::editmode ($_user, $_tree);
    my $signedon = Security::isSignedOn();

    my $drawline = 0;

    if ($_user =~ /\w+/ || $_tree =~ /\w+/ ||$_familyname =~ /\w+/) {
        print "<TABLE BGCOLOR=$Colour::MenuBack WIDTH=100%>\n";
        print "<TR><TD>\n";

        if ($_user =~ /\w+/) {
            print "User: $_user<BR>\n";
            $drawline = 1;
        }
        if ($_tree =~ /\w+/) {
            print "Tree: ". TreesDB::treeName ($_user, $_tree) . " <BR>\n";
            $drawline = 1;
        }
        if ($_familyname =~ /\w+/) {
            print "Family: $_familyname<BR>\n";
            $drawline = 1;
        }

        print "</TR></TD></TABLE>\n";
    }

    if ($drawline) {
        print "<HR>\n";
    }

    print "<TABLE BGCOLOR=$Colour::MenuItemBack WIDTH=100%>\n";

    print "<TR><TD><A HREF=../../gen/>Help!</A></TD></TR>\n";
    print "<TR><TD BGCOLOR=$Colour::MenuBack>&nbsp;</TD></TR>\n";

    if ($_tree =~ /\w+/) {
        if ($module ne "listall" || $_familyname =~ /\w+/) {
            print "<TR><TD>\n";
            print "<A HREF=listall.pl?tree=$_tree&user=$_user TARGET=FT_NAV>List Everyone</A><BR>\n";
            print "</TD></TR>\n";
        }

        if ($module ne "listall" && $_familyname =~ /\w+/) {
            print "<TR><TD>\n";
            print ("<A HREF=listall.pl?tree=$_tree&user=$_user&familyname=$_familyname TARGET=FT_NAV>List all in $_familyname</A><BR>\n");
            print "</TD></TR>\n";
        }

        if ($module ne "showhistory") {
            print "<TR><TD>\n";
            print ("<A HREF=showhistory.pl?tree=$_tree&user=$_user&familyname=$_familyname TARGET=FT_NAV>Family History</A><BR>\n");
            print "</TD></TR>\n";
        }

        if ($module ne "familynames") {
            print "<TR><TD>\n";
            print "<A HREF=listfamilynames.pl?tree=$_tree&user=$_user TARGET=FT_NAV>Family Names</A><BR>\n";
            print "</TD></TR>\n";
        }
    }

    if ($module ne "listtrees") {
        print "<TR><TD>\n";
        print "<A HREF=listtrees.pl?user=$_user TARGET=FT_NAV>Family Trees</A><BR>\n";
        print "</TD></TR>\n";
    }

    if ($module ne "listlinks" && $editmode) {
        print "<TR><TD>\n";
        print "<A HREF=listlinks.pl?user=$_user&tree=$_tree&familyname=$_familyname TARGET=FT_NAV>Links to other trees</A><BR>\n";
        print "</TD></TR>\n";
    }

    if ($module ne "search") {
            print "<TR><TD>\n";
        print <<EOF
<A HREF=searchperson.pl?tree=$_tree&user=$_user&familyname=$_familyname&nolink=Y TARGET=FT_NAV>Search</A>
</TD></TR>
<TR><TD>
<A HREF='' ONCLICK='opensearchwin();return false;'>Open search window</A><BR>
EOF
;
            print "</TD></TR>\n";
    }


    print "<TR><TD BGCOLOR=$Colour::MenuBack>&nbsp;</TD></TR>\n";

    if ($module ne 'showlog' && $_tree =~ /\w+/) {
        print "<TR><TD><A HREF=showlog.pl?tree=$_tree&user=$_user&familyname=$_familyname>Change Log</A></TD></TR>\n";
        print "<TR><TD BGCOLOR=$Colour::MenuBack>&nbsp;</TD></TR>\n";
    }

    if ($module ne "signon") {
        if ($editmode) {
           print <<EOF
<TR><TD>
<A HREF=addperson.pl?tree=$_tree&user=$_user TARGET=FT_DATA>Add a person</A><BR>
</TD></TR>
<TR><TD>
<A HREF=addlink.pl?tree=$_tree&user=$_user TARGET=FT_DATA>Link to person in another tree</A><BR>
</TD></TR>
EOF
;
        }

        if ($signedon) {
            $thisURI = $ENV{'REQUEST_URI'};
            $thisURI =~ s/=/%3D/g;
            $thisURI =~ s/\&/%26/g;
            $thisURI =~ s/\?/%3F/g;

            print <<EOF
<TR><TD>
<A HREF="signoff.pl?url=$thisURI">Sign off</A><BR>
</TD></TR>
EOF
;
        } elsif ($module ne "signon") {
            print <<EOF
<TR><TD>
<A HREF=signon.pl?tree=$_tree>Sign On</A><BR>
</TD></TR>
EOF
;
        }
    }

    print "<TR><TD BGCOLOR=$Colour::MenuBack>&nbsp;</TD></TR>\n";

    if ($module ne "adduser") {
        print <<EOF
<TR><TD>
<A HREF=adduser.pl>Register</A><BR>
</TD></TR>
EOF
;
    }

    if ($signedon && $module ne "addtree") {
        print <<EOF
<TR><TD>
<A HREF=addtree.pl?user=$_user>Start a new tree</A><BR>
</TD></TR>
EOF
;
    }


print "</TABLE>\n";
}

1

