
use Log;

package LinksDB;


sub resolve {

    my $_tree = $_[0];
    my $_nick = $_[1];

    my $t;
    my $n;

    if ($_nick =~ /\w+\.\w+/) {
        ($t, $n) = split (/\./, $_nick);
    } else {
        $t = $_tree;
        $n = $_nick;
    }

    open (LINKS, "<./trees/$t/links.idx");

    LINK: while (<LINKS>) {
        chomp;
        (my $tt, my $tn, my $ot, my $on) = split (/\|/);

        if ($tt eq $t && $tn eq $n) {
            $t = $ot;
            $n = $on;
            last LINK;
        }
    }

    close (LINKS);

    if ($t eq $_tree) {
        return $n;
    } else {
        return "$t.$n";
    }
}

sub fullyResolve {

    my $_tree = $_[0];
    my $_nick = $_[1];

    my $t;
    my $n;

    if ($_nick =~ /\w+\.\w+/) {
        ($t, $n) = split (/\./, $_nick);
    } else {
        $t = $_tree;
        $n = $_nick;
    }

    open (LINKS, "<./trees/$t/links.idx");

    LINK: while (<LINKS>) {
        chomp;
        (my $tt, my $tn, my $ot, my $on) = split (/\|/);

        if ($tt eq $t && $tn eq $n) {
            $t = $ot;
            $n = $on;
            last LINK;
        }
    }

    close (LINKS);

    return "$t.$n";
}


sub addLink {

    my $user = $_[0];
    my $tree = $_[1];
    my $nick = $_[2];
    my $totree = $_[3];
    my $tonick = $_[4];

    open (LINKS, ">>./trees/$tree/links.idx");

    print LINKS "$tree|$nick|$totree|$tonick\n";

    close (LINKS);

    Log::log ($user, $tree, "Added link $nick to $totree.$tonick");

    return "";
}

sub isKnown {

    my $user = $_[0];
    my $tree = $_[1];
    my $nick = $_[2];

    open (LINKS, "<./trees/$tree/links.idx");

    LINK: while (<LINKS>) {
        chomp;
        (my $tt, my $tn) = split (/\|/);

        if ($tt eq $_tree && $tn eq $_nick) {
            close (LINKS);
            return 1;
        }
    }

    close (LINKS);

    return (0);
}

sub deleteLink {

    my $_user=$_[0];
    my $_tree=$_[1];
    my $_nick=$_[2];

    open (LINKS, "<./trees/$_tree/links.idx");
    open (NEWLINKS, ">./trees/$_tree/links.tmp.idx");
    while (<LINKS>) {
        chomp;
        (my $t, my $k) = split (/\|/);
        if ($k ne $_nick) {
            print NEWLINKS "$_\n";
        }
    }
    close (NEWLINKS);
    close (LINKS);

    unlink "./trees/$_tree/links.idx";
    rename "./trees/$_tree/links.tmp.idx", "./trees/$_tree/links.idx";

    Log::log ($_user, $_tree, "Deleted link $_nick");
}


1

