
package RemoteDB;


sub eventsFor {

    my $_tree = $_[0];
    my $_nick = $_[1];

    if ($_nick =~ /\w+\.\w+/) {
        ($_tree, $_nick) = split (/\./, $_nick);
    }

    my @el;

    open (EVENTS, "<./trees/$_tree/events.db");

    while (<EVENTS>) {
        chomp;

        (my $k, my $n, my $type, my $d, my $p1, my $p2, my $w, my $t, my $r, my $c) = split (/\|/);

        if ($t eq $_tree && ($n eq $_nick || $p1 eq $_nick || $p2 eq $_nick)) {
            $n = LinksDB::fullyResolve ($t, $n);
            $p1 = LinksDB::fullyResolve ($t, $p1);
            $p2 = LinksDB::fullyResolve ($t, $p2);

            my $e = "$k|$n|$type|$d|$p1|$p2|$w|$t|$r|$c";

            push @el, $e;
        }
    }

    close (EVENTS);

    return @el;
}



sub personDetails {

    my $_tree = $_[0];
    my $_nick = $_[1];

    $_nick = LinksDB::resolve ($_tree, $_nick);

    if ($_nick =~ /\w+\.\w+/) {
        ($_tree, $_nick) = split (/\./, $_nick);
    }

    open (PEOPLE, "<./trees/$_tree/people.idx");

    while (<PEOPLE>) {
        ($n) = split (/\|/);
        if ($n eq $_nick) {
            chomp;
            (my $k, my $d, my $s, my $l, my $t, my $c) = split (/\|/);

            if ($_tree eq $t) {
                close (PEOPLE);
                return ("$t.$k", $d, $s, $l, $t, $c);
            }
        }
    }

    close (PEOPLE);

    return;
}


sub parents {

    my $_tree = $_[0];
    my $_nick = $_[1];

    if ($_nick =~ /\w+\.\w+/) {
        ($_tree, $_nick) = split (/\./, $_nick);
    }

    open (PARENTS, "<./trees/$_tree/parents.db");

    while (<PARENTS>) {
        chomp;

        (my $n, my $m, my $f, my $t) = split (/\|/);

        if ($n eq $_nick && $t eq $_tree) {
            close (PARENTS);
            return ("$t.$m", "$t.$f");
        }
    }

    close (PARENTS);

    return ();
}


sub allParents {

    my $_tree = $_[0];
    my $_nick = $_[1];

    if ($_nick =~ /\w+\.\w+/) {
        ($_tree, $_nick) = split (/\./, $_nick);
    }

    open (PARENTS, "<./trees/$_tree/parents.db");

    my @pl;


    while (<PARENTS>) {
        chomp;
        (my $n, my $m, my $f, my $t) = split (/\|/);
        if ($t eq $_tree) {
            push @pl, [("$t.$n", "$t.$m", "$t.$f")];
        }
    }

    close (PARENTS);

    return @pl;
}


sub parentalConnections {

    my $_tree = $_[0];
    my $_nick = $_[1];

    if ($_nick =~ /\w+\.\w+/) {
        ($_tree, $_nick) = split (/\./, $_nick);
    }

    open (PARENTS, "<./trees/$_tree/parents.db");

    my @pl;

    while (<PARENTS>) {
        chomp;
        (my $n, my $m, my $f, my $t) = split (/\|/);
        if ($t eq $_tree && ($n eq $_nick || $m eq $_nick || $f eq $_nick)) {
            push @pl, [("$t.$n", "$t.$m", "$t.$f")];
        }
    }

    close (PARENTS);

    return @pl;
}


sub children {

    my $_tree = $_[0];
    my $_nick = $_[1];

    if ($_nick =~ /\w+\.\w+/) {
        ($_tree, $_nick) = split (/\./, $_nick);
    }

    my @cl;

    open (PARENTS, "<./trees/$_tree/parents.db");

    while (<PARENTS>) {
        chomp;

        (my $n, my $m, my $f, my $t) = split (/\|/);

        if (($m eq $_nick || $f eq $_nick) && $_tree eq $t) {
            push @cl, "$t.$n";
        }
    }

    close (PARENTS);

    return @cl;
}


1

