#!/usr/bin/perl

use integer;

package TreesDB;

my $init = 0;
my %treelist;

sub addTree {

    my $user = $_[0]; shift;
    my $tree = $_[0]; shift;
    my $name = $_[0]; shift;
    my $owner = $_[0]; shift;
    my $users = join (';', @_);

    mkdir "./trees/$tree", 0755;

    open (TREES, ">>./trees.idx");

    print TREES "$tree|$name|$owner|$users\n";

    close (TREES);

    return "";
}



sub initialise {

    open (TREES, "<./trees.idx");

    while (<TREES>) {
        chomp;

        (my $n) = split (/\|/);

        $treelist{$n} = $_;
    }

    close (TREES);

    $init = 1;
}


sub isKnown {

    my $user = $_[0];
    my $tree = $_[1];

    if (!$init) {
        initialise;
    }

    return ($treelist{$tree} =~ /\w+/);
}


sub replaceTree {

    my $user = $_[0]; shift;
    my $tree = $_[0]; shift;
    my $name = $_[0]; shift;
    my $owner = $_[0]; shift;
    my $users = join (';', @_);

    my $set = 0;

    open (TREES, "<./trees.idx");
    open (NEWTREES, ">./trees.tmp.idx");

    PERSON: while (<TREES>) {
        ($n) = split (/\|/);
        if (!$set && $n eq $tree) {
            $set = 1;
            print NEWTREES "$tree|$name|$owner|$users\n";
            next PERSON;
        } else {
            print NEWTREES $_;
        }
    }

    if (!$set) {
        print NEWTREES "$tree|$name|$owner|$users\n";
    }

    close (NEWTREES);
    close (TREES);

    unlink "./trees.idx";
    rename "./trees.tmp.idx", "./trees.idx";
}


sub treeName {

    my $user = $_[0];
    my $tree = $_[1];

    if (! $init) {
        initialise;
    }

    (my $k, my $n) = split (/\|/, $treelist{$tree});

    return $n;
}


sub deleteTree {

    my $_user=$_[0];
    my $_tree=$_[1];

    open (TREES, "<./trees.idx");
    open (NEWTREES, ">./trees.tmp.idx");
    while (<TREES>) {
        (my $k) = split (/\|/);
        if ($k ne $_tree) {
            print NEWTREES "$_";
        }
    }
    close (NEWTREES);
    close (TREES);

    unlink "./trees.idx";
    rename "./trees.tmp.idx", "./trees.idx";

    if ($init) {
        delete $treelist{$_key};
    }
}


sub allTrees {

    my $user = $_[0];

    if (! $init) {
        initialise;
    }

    return keys %treelist;
}


sub allTreeDetails {

    my $user = $_[0];

    if (! $init) {
        initialise;
    }

    my @tl;

    foreach $v (values %treelist) {
        push @tl, [split (/\|/, $v)];
    }

    return @tl;
}


sub allTreesFor {

    my $user = $_[0];

    if (! $init) {
        initialise;
    }

    my @tl;

    foreach $v (values %treelist) {
        (my $t, my $n, my $o, my $u) = split (/\|/, $v);
        if ($o eq $user) {
            push @tl, [split (/\|/, $v)];
        } else {
            @us = split (/\;/, $u);
            EDITOR: foreach $e (@us) {
                if ($e eq $user) {
                    push @tl, [split (/\|/, $v)];
                    last EDITOR;
                }
            }
        }
    }

    return @tl;
}

1
