#!/usr/bin/perl

use Log;

use integer;

package UserDB;

my $init = 0;
my %userslist;

sub addUser {

    my $user = $_[0];
    my $password = $_[1];
    my $realname = $_[2];
    my $email = $_[3];
    my $link = $_[4];

    open (USERS, ">>./users.db");

    print USERS "$user|N|$password|$realname|$link|$email\n";

    close (USERS);

    Log::log ($user, "", "Added user $user $realname");

    return "";
}



sub initialise {

    open (USERS, "<./users.db");

    while (<USERS>) {
        chomp;

        (my $u, my $f, my $p, my $n, my $l, my $e) = split (/\|/);

        $userslist{$u} = $_;
    }

    close (USERS);

    $init = 1;
}


sub isKnown {

    my $user = $_[0];

    if (! $init) {
        initialise;
    }

    return ($userslist{$user} =~ /.+/);
}


sub replaceUser {

    my $user = $_[0];

    my $set = 0;

    open (USERS, "<./users.db");
    open (NEWUSERS, ">./users.tmp.db");

    PERSON: while (<USERS>) {
        ($n) = split (/\|/);
        if (!$set && $n eq $nick) {
            $set = 1;
            print NEWUSERS "$nick|$familyname,$othernames|$sex|$link|$tree\n";
            next PERSON;
        } else {
            print NEWUSERS $_;
        }
    }

    if (!$set) {
        print NEWUSERS "$nick|$familyname,$othernames|$sex|$link|$tree\n";
    }

    close (NEWUSERS);
    close (USERS);

    unlink "./users.db";
    rename "./users.tmp.db", "./users.db";

    Log::log ($user, $tree, "Modified person $nick");
}


sub realname {

    my $user = $_[0];

    if (! $init) {
        initialise;
    }
    (my $u, my $f, my $p, my $n) = split (/\|/, $userslist{$user});

    return $n;
}


sub deleteUser {

    my $_user=$_[0];

    open (USERS, "<./users.db");
    open (NEWUSERS, ">./users.tmp.db");
    while (<USERS>) {
        (my $k) = split (/\|/);
        if ($k ne $_user) {
            print NEWUSERS "$_";
        }
    }
    close (NEWUSERS);
    close (USERS);

    unlink "./users.db";
    rename "./users.tmp.db", "./users.db";

    if ($init) {
        delete $userslist{$_user};
    }

    Log::log ($user, "", "Deleted user $_user");
}


sub user {

    my $_user=$_[0];

    if (! $init) {
        initialise;
    }

    return split (/\|/, $userslist{$_user});
}


sub allUsersDetails {

    if (! $init) {
        initialise;
    }

    my @pl;

    foreach my $v (values %userslist) {
        push @pl, [split (/\|/, $v)];
    }
    return @pl;
}


sub allUsers {

    if (! $init) {
        initialise;
    }

    return keys %userslist;
}


1
