#!/usr/bin/perl

use CGI qw(:standard escapeHTML);
use AliasesDB;
use Colour;
use Date;
use EventDB;
use Name;
use PeopleDB;
use Security;

use integer;

$_user=param ('user');
$_tree=param ('tree');

if (!Security::editmode ($_user, $_tree)) {
    exit;
}

print <<EOF
Content-type: text/html

<HTML>
<HEAD>
<TITLE>Add new person</TITLE>
<SCRIPT LANGUAGE=JAVASCRIPT>
window.focus(self);
</SCRIPT>
</HEAD>
<BODY BGCOLOR=$Colour::WindowBack>
EOF
;


if (!Security::editmode ($_user, $_tree)) {
    $error = "Modification not allowed";
} else {
    $nick = param('nick');

    if ($nick =~ /\w+/)
    {
    
        $fn = Name::capitalise (param ('familyname'));
        $on = Name::capitalise (param ('othernames'));
        $bdate = param('bornc').param('borny').param('bornm').param('bornd');
        $ddate = param('diedc').param('diedy').param('diedm').param('diedd');

        if ($nick !~ /^\w+$/) {
            $error = "REJECTED: Badly formed nick name - must be only alphanumeric characters.";
        } elsif (!Name::isValid ($fn) && !Name::isEmpty ($fn)) {
            $error = "REJECTED: Invalid characters in the family name";
        } elsif (!Name::isValid ($on) && !Name::isEmpty ($on)) {
            $error = "REJECTED: Invalid characters in the other names";
        } elsif (Date::aLTb ($ddate, $bdate)) {
            $error = "REJECTED: Died before birth";
        } elsif (!PeopleDB::isKnown ($_user, $_tree, $nick)) {

            PeopleDB::addPerson ($_user, $_tree, $nick, $fn, $on, param ('sex'), param ('homepage'), param ('comment'), param('link'));

            $bornwhere = param ('bornwhere');
            $birthref = param ('birthref');
            $birthcomment = param ('birthcomment');
            if ($bdate =~ /\w+/ || $bornwhere =~ /\w+/ || $birthref =~ /\w+/ || $birthcomment =~ /\w+/) {
                EventDB::addEvent ($_user, $_tree, $nick, "B", $bdate, $bornwhere, $p1, $p2, $birthref, $birthcomment);
            }

            $diedwhere = param ('diedwhere');
            $deathref = param ('deathref');
            $deathcomment = param ('deathcomment');
            if ($ddate =~ /\w+/ || $diedwhere =~ /\w+/ || $deathref =~ /\w+/ || $deathcomment =~ /\w+/) {
                EventDB::addEvent ($_user, $_tree, $nick, "D", $ddate, $diedwhere, $p1, $p2, $deathref, $deathcomment);
            }

            $aka1=param('aka1');
            $aka2=param('aka2');
            $aka3=param('aka3');
            $aka4=param('aka4');
            $aka5=param('aka5');
            $aka6=param('aka6');
            $aka7=param('aka7');
            $aka8=param('aka8');
            $aka9=param('aka9');


            if ($aka1 =~ /\w+/) {
                AliasesDB::addAlias ($_user,$_tree, $nick, $aka1, $aka2, $aka3, $aka4, $aka5, $aka6, $aka7, $aka8, $aka9);
            }
            print <<EOF
<SCRIPT LANGUAGE=JAVASCRIPT>
navWin = window.open ("", "FT_NAV");
navWin.location.href=navWin.location;
</SCRIPT>
EOF
;
        }
        else
        {
            $error = "REJECTED: '$nick' is already in use.";
        }
    }
}

print <<EOF
<TABLE WIDTH=100% BORDER=1 BGCOLOR=$Colour::DataBack>
<TR><TD COLSPAN=2 BGCOLOR=$Colour::HeaderBack>
<CENTER>
<H3>Add a new person</H3>
</CENTER>
</TD></TR>
<TR><TD >
<CENTER>
$error
</CENTER>
<FORM METHOD=get ACTION=addperson.pl>
<INPUT TYPE=HIDDEN NAME=user VALUE=$_user>
<INPUT TYPE=HIDDEN NAME=tree VALUE=$_tree>
<TABLE>
<TR><TD>Person ID:</TD><TD><INPUT TYPE=TEXT NAME=nick></TD></TR>
<TR><TD>Family Name:</TD><TD><INPUT TYPE=TEXT NAME=familyname></TD></TR>
<TR><TD>Other Names:</TD><TD><INPUT TYPE=TEXT NAME=othernames></TD></TR>
<TR><TD>Sex:</TD><TD><SELECT NAME=sex><OPTION>F<OPTION>M</SELECT></TD></TR>
<TR><TD VALIGN=TOP>Comment:</TD><TD><TEXTAREA ROWS=3 COLS=40 NAME=comment></TEXTAREA></TD></TR>
EOF
;

print <<EOF
<TR><TD>Born:</TD><TD>
Century:
<SELECT NAME=bornc>
EOF
;

print "<OPTION VALUE=\"  \">\n";

for ($i=14; $i <=20; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d>$d\n");
}


print <<EOF
</SELECT>
Year:
<SELECT NAME=borny>
EOF
;


print "<OPTION VALUE=\"  \">\n";

for ($i=0; $i <=99; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d>$d\n");
}

print <<EOF
</SELECT>
Month:
<SELECT NAME=bornm>
EOF
;

@mon = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "N
ov", "Dec");

print "<OPTION VALUE=\"  \">\n";

for ($i=0; $i <=11; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d>$mon[$i]\n");
}


print <<EOF
</SELECT>
Day:
<SELECT NAME=bornd>
EOF
;

print "<OPTION VALUE=\"  \">\n";

for ($i=1; $i <=31; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d>$d\n");
}

print <<EOF
</SELECT>
</TD></TR>
<TR><TD>
Where:</TD><TD><INPUT TYPE=TEXT NAME=bornwhere>
</TD></TR>
<TR><TD>
Ref:</TD><TD><INPUT TYPE=TEXT NAME=birthref>
</TD></TR>
<TR><TD VALIGN=TOP>
Comment:</TD><TD><TEXTAREA NAME=birthcomment ROWS=3 COLS=40></TEXTAREA>
</TD></TR>
EOF
;



print <<EOF
<TR><TD>Died:</TD><TD>
Century:
<SELECT NAME=diedc>
EOF
;

print "<OPTION VALUE=\"  \">\n";

for ($i=14; $i <=20; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d>$d\n");
}


print <<EOF
</SELECT>
Year:
<SELECT NAME=diedy>
EOF
;


print "<OPTION VALUE=\"  \">\n";

for ($i=0; $i <=99; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d>$d\n");
}

print <<EOF
</SELECT>
Month:
<SELECT NAME=diedm>
EOF
;

@mon = ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "N
ov", "Dec");

print "<OPTION VALUE=\"  \">\n";

for ($i=0; $i <=11; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d>$mon[$i]\n");
}


print <<EOF
</SELECT>
Day:
<SELECT NAME=diedd>
EOF
;

print "<OPTION VALUE=\"  \">\n";

for ($i=1; $i <=31; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d>$d\n");
}

print <<EOF
</SELECT>
</TD></TR>
<TR><TD>
Where:</TD><TD><INPUT TYPE=TEXT NAME=diedwhere>
</TD></TR>
<TR><TD>
Ref:</TD><TD><INPUT TYPE=TEXT NAME=deathref>
</TD></TR>
<TR><TD VALIGN=TOP>
Comment:</TD><TD><TEXTAREA ROWS=3 COLS=40 NAME=deathcomment></TEXTAREA>
</TD></TR>
EOF
;

print <<EOF
<TR><TD>Also known as:</TD><TD><INPUT TYPE=TEXT NAME=aka1></TD></TR>
<TR><TD></TD><TD><INPUT TYPE=TEXT NAME=aka2></TD></TR>
<TR><TD></TD><TD><INPUT TYPE=TEXT NAME=aka3></TD></TR>
<TR><TD></TD><TD><INPUT TYPE=TEXT NAME=aka4></TD></TR>
<TR><TD></TD><TD><INPUT TYPE=TEXT NAME=aka5></TD></TR>
<TR><TD></TD><TD><INPUT TYPE=TEXT NAME=aka6></TD></TR>
<TR><TD></TD><TD><INPUT TYPE=TEXT NAME=aka7></TD></TR>
<TR><TD></TD><TD><INPUT TYPE=TEXT NAME=aka8></TD></TR>
<TR>
<TD>Further Information (URL):</TD>
<TD><INPUT TYPE=TEXT NAME=link></TD>
</TR>
<TR>
<TD>Home Page (URL):</TD>
<TD><INPUT TYPE=TEXT NAME=homepage></TD>
</TR>
</TABLE>
<BR>
<CENTER>
<INPUT TYPE=SUBMIT VALUE=Submit> <INPUT TYPE=RESET><BR>
</CENTER>
</FORM>
</TD></TR>
</TABLE>
</CENTER>
</BODY>
</HTML>
EOF
;

