#!/usr/bin/perl

use CGI qw(:standard escapeHTML);
use Security;
use Colour;
use Date;
use EventDB;
use ParentsDB;
use PeopleDB;
use FTUtility;

use integer;


$_user=param ('user');
$_tree=param ('tree');
$_nick=param ('nick');
$_familyname=param ('familyname');

$editmode=Security::editmode ($_user, $_tree);


$mother = "";
$father = "";

@parents = ParentsDB::allParents ($_user, $_tree, $_nick);

foreach $re (@parents) {
    $key = $re->[0];
    $m = $re->[1];
    $f = $re->[2];

    $mother{$key} = $m;
    $father{$key} = $f;
    $child{$m} = 1;
    $child{$f} = 1;
}


$name = PeopleDB::fullName ($_user, $_tree, $_nick);

print <<EOF
Content-type: text/html

<HTML>
<HEAD>
<SCRIPT LANGUAGE=JAVASCRIPT>
top.focus();


function name (t)
{

    window.status = "Details of " + t;
    return true;
}

function desc (t)
{

    window.status = "Descendants of " + t;
    return true;
}

function anc (t)
{

    window.status = "Ancestors of " + t;
    return true;
}

function nodesc()
{
    window.status = "";
    return true;
}

</SCRIPT>

<TITLE>Ancestors of $name</TITLE>
EOF
;

FTUtility::navScripts;

print <<EOF
</HEAD>
<BODY BGCOLOR=$Colour::WindowBack>
EOF
;

print <<EOF
<TABLE BORDER=1 WIDTH=100%>
<TR><TD BGCOLOR=$Colour::HeaderBack COLSPAN=2>
<CENTER><H3>Ancestors of $name</H3></CENTER>
</TD></TR>
<TR><TD VALIGN=TOP WIDTH=180>
EOF
;

FTUtility::navPanel ("ancestors", $_user, $_tree, $_familyname);

print <<EOF
</TD><TD BGCOLOR=$Colour::ListBack>
EOF
;

sub showparentsof {

    my $n = $_[0];

    if ($n !~ /\w+/) {
        print "<LI> Unknown\n";
        return;
    }

    my $name = PeopleDB::fullName ($_user, $_tree, $n);

    my $c = EventDB::eventDate ($_tree, $n, 'B');
    my $d = EventDB::eventDate ($_tree, $n, 'D');

    print "<LI>";
    if ($child{$n}) {
        print "<A HREF=descendants.pl?tree=$_tree&user=$_user&nick=$n&familyname=$_familyname TARGET=FT_NAV ONMOUSEOVEr='return desc(\"$name\");' ONMOUSEOUT='return nodesc();'> &lt; </A>";
    }
    print "<A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$n&familyname=$_familyname TARGET=FT_DATA ONMOUSEOVEr='return name(\"$name\");' ONMOUSEOUT='return nodesc();'>$name</A>";
    if ($mother{$n} || $father{$n}) {
        print "<A HREF=ancestors.pl?tree=$_tree&user=$_user&nick=$n&familyname=$_familyname TARGET=FT_NAV ONMOUSEOVEr='return anc(\"$name\");' ONMOUSEOUT='return nodesc();'> &gt; </A>";
    }
    print " " . Date::formatYYYY ($c) . " - " . Date::formatYYYY ($d);
    print "\n";

    my $m = "";
    $m = $mother{$n};

    my $f = "";
    $f = $father{$n};

    if ($m !~ /\w+/ && $f !~ /\w+/) {
        return;
    }

    print "<UL>\n";

    showparentsof ($m);
    showparentsof ($f);

    print "</UL>\n";
}


showparentsof ($_nick);

print <<EOF
</TD></TR>
</TABLE>
</BODY>
</HTML>
EOF
;

