#!/usr/bin/perl

use CGI qw(:standard escapeHTML);
use Security;
use Colour;
use Date;
use EventDB;
use ParentsDB;
use PeopleDB;
use FTUtility;

use integer;


$_user=param ('user');
$_tree=param ('tree');
$_nick=param ('nick');
$_familyname=param ('familyname');

$editmode=Security::editmode ($_user, $_tree);

$mother = "";
$father = "";

@parents = ParentsDB::allParents ($_user, $_tree, $_nick);

print <<EOF
Content-type: text/html

<HTML>
<HEAD>
<SCRIPT LANGUAGE=JAVASCRIPT>
top.focus();


function name (t)
{

    window.status = "Details of " + t;
    return true;
}

function desc (t)
{

    window.status = "Descendants of " + t;
    return true;
}

function anc (t)
{

    window.status = "Ancestors of " + t;
    return true;
}

function nodesc()
{
    window.status = "";
    return true;
}

</SCRIPT>

<TITLE>Descendants of $name</TITLE>
EOF
;

foreach $re (@parents) {
    $key = $re->[0];
    $m = $re->[1];
    $f = $re->[2];

    push @{$children{$m}}, $key;
    push @{$children{$f}}, $key;
    $parents{$key} = 1;
}


$name = PeopleDB::fullName ($_user, $_tree, $_nick);

FTUtility::navScripts;

print <<EOF
</HEAD>
<BODY BGCOLOR=$Colour::WindowBack>
EOF
;

print <<EOF
<TABLE BORDER=1 WIDTH=100%>
<TR><TD BGCOLOR=$Colour::HeaderBack COLSPAN=2>
<CENTER><H3>Descendants of $name</H3></CENTER>
</TD></TR>
<TR><TD WIDTH=15 VALIGN=TOP>
EOF
;

FTUtility::navPanel ("descendants", $_user, $_tree, $_familyname);

print <<EOF
</TD><TD BGCOLOR=$Colour::ListBack>
EOF
;

sub showchildrenof {

    my $n = $_[0];

    if ($n !~ /\w+/) {
        print "<LI> Unknown\n";
        return;
    }

    my $name = PeopleDB::fullName ($_user, $_tree, $n);

    my $c = EventDB::eventDate ($_tree, $n, 'B');
    my $d = EventDB::eventDate ($_tree, $n, 'D');

    print "<LI>";
    if ($parents{$n}) {
        print "<A HREF=ancestors.pl?tree=$_tree&user=$_user&nick=$n&familyname=$_familyname TARGET=FT_NAV ONMOUSEOVER='return anc(\"$name\");' ONMOUSEOUT='return nodesc();'> &lt; </A>";
    }
    print "<A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$n&familyname=$_familyname TARGET=FT_DATA ONMOUSEOVER='return name(\"$name\");' ONMOUSEOUT='return nodesc();'>$name</A>";
    if ($children{$n}) {
        print "<A HREF=descendants.pl?tree=$_tree&user=$_user&nick=$n&familyname=$_familyname TARGET=FT_NAV ONMOUSEOVER='return desc(\"$name\");' ONMOUSEOUT='return nodesc();'> &gt; </A>";
    }

    print " " . Date::formatYYYY ($c) . " - " . Date::formatYYYY ($d);
    print "\n";

    my $m = "";
    my @kids = @{$children{$n}};

    my %kd;

    foreach my $k (@kids) {
        $kd{$k}=EventDB::eventDate ($_tree, $k, 'B');
    }

    print "<UL>\n";

    foreach $k (sort {$kd{$a} cmp $kd{$b}} keys %kd) {
        showchildrenof ($k);
    }

    print "</UL>\n";
}


showchildrenof ($_nick);

print <<EOF
</TD></TR>
</TABLE>
</BODY>
</HTML>
EOF
;

