#!/usr/bin/perl

use CGI qw(:standard escapeHTML);
use Colour;
use Date;
use EventDB;
use PeopleDB;


use integer;

$_user=param ('user');
$_tree=param ('tree');
$_nick=param ('nick');
$_key=param ('key');
$_familyname=param ('familyname');

$month{"00"}="Jan";
$month{"01"}="Feb";
$month{"02"}="Mar";
$month{"03"}="Apr";
$month{"04"}="May";
$month{"05"}="Jun";
$month{"06"}="Jul";
$month{"07"}="Aug";
$month{"08"}="Sep";
$month{"09"}="Oct";
$month{"10"}="Nov";
$month{"11"}="Dec";


@people = PeopleDB::allPeople ($_user, $_tree);

$name = PeopleDB::fullName ($_user, $_tree, $_nick);

$refbirth = EventDB::eventDate ($_tree, $_nick, "B");
$refdeath = EventDB::eventDate ($_tree, $_nick, "D");

PERSON: foreach $n (@people) {
    $b = EventDB::eventDate ($_tree, $n, "B");
    $d = EventDB::eventDate ($_tree, $n, "D");

    if (Date::aGTb ($b, $refdeath)) {
         next PERSON;
    }
    if (Date::aLTb ($d, $refbirth)) {
         next PERSON;
    }

    if ($n ne $_nick) {
        $livingpeople{$n} = PeopleDB::fullName ($_user, $_tree, $n);
    }
}

($type, $when, $where, $p1, $p2, $ref, $comment) = EventDB::eventDetailsByKey ($_user, $_tree, $_key);

$eventc=substr ($when,0,2);
$eventy=substr ($when,2,2);
$eventm=substr ($when,4,2);
$eventd=substr ($when,6,2);

print <<EOF
Content-type: text/html

<HTML>
<HEAD><TITLE>Modify event for $name</TITLE>
<SCRIPT LANGUAGE=JAVASCRIPT>
function checkdel (k)
{
    if (confirm ("Delete this event (" + k + ")?"))
       top.location.href='delevent.pl?tree=$_tree&user=$_user&nick=$_nick&key='+escape(k);
}
</SCRIPT>
</HEAD>
<BODY BGCOLOR=$Colour::WindowBack>
<TABLE BGCOLOR=#F0F0F0 WIDTH=100% BORDER=1>
<TR><TD BGCOLOR=$Colour::HeaderBack>
<CENTER>
<H3>Modify event for $name</H3>
</CENTER>
</TD></TR>
<TR><TD BGCOLOR=$Colour::DataBack>
EOF
;


print "<FORM METHOD=GET ACTION=modevent.pl>\n";
print "<INPUT TYPE=HIDDEN NAME=tree VALUE=$_tree>\n";
print "<INPUT TYPE=HIDDEN NAME=user VALUE=$_user>\n";
print "<INPUT TYPE=HIDDEN NAME=nick VALUE=$_nick>\n";
print "<INPUT TYPE=HIDDEN NAME=familyname VALUE=$_familyname>\n";
print "<INPUT TYPE=HIDDEN NAME=key VALUE=\"$_key\">\n";

print "<TABLE WIDTH=100%>\n";

@et = EventDB::eventTypes ($_user, $_tree);

print <<EOF
<TR><TD ALIGN=RIGHT VALIGN=TOP>Event:</TD><TD ALIGN=LEFT VALIGN=TOP><SELECT NAME=event>
EOF
;

foreach $e (@et) {

    $code = $e->[0];
    $text = $e->[1];

    print "<OPTION VALUE=$code";
    if ($code eq $type) {
        print " SELECTED";
    }
    print ">$text\n";
}

print <<EOF
</SELECT>
</TD></TR>
EOF
;

print "<TR><TD>&nbsp;</TD><TD>\n";

print "<SELECT NAME=p1>\n<OPTION>\n";
foreach $n (sort {$livingpeople{$a} cmp $livingpeople{$b}} keys %livingpeople) {
    $b = EventDB::eventDate ($_tree, $n, "B");

    print "<OPTION VALUE=$n";
    if ($n eq $p1) {
        print " SELECTED";
    }
    print ">$livingpeople{$n} ($n) " . Date::formatYYYY ($b);
}
print "</SELECT>\n";
print "</TD></TR><TR><TD ALIGN=RIGHT VALIGN=TOP>\n";
print "and: \n";
print "</TD><TD>\n";
print "<SELECT NAME=p2>\n<OPTION>\n";
foreach $n (sort {$livingpeople{$a} cmp $livingpeople{$b}} keys %livingpeople) {
    $b = EventDB::eventDate ($_tree, $n, "B");

    print "<OPTION VALUE=$n";
    if ($n eq $p2) {
        print " SELECTED";
    }
    print ">$livingpeople{$n} ($n) " . Date::formatYYYY ($b);
}
print "</SELECT>\n<BR>";
print "</TD></TR>\n";

print <<EOF
<TR><TD ALIGN=RIGHT VALIGN=TOP>When: 
</TD><TD ALIGN=LEFT VALIGN=TOP>
Century:
<SELECT NAME=eventc>
EOF
;

print "<OPTION VALUE=\"  \"";
if ($eventc !~ /\w+/) {
    print " SELECTED"
}
print ">\n";

for ($i=14; $i <=20; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d");
    if ($d eq $eventc) {
        print " SELECTED";
    }
    print (">$d\n");
}


print <<EOF
</SELECT>
Year:
<SELECT NAME=eventy>
EOF
;

print "<OPTION VALUE=\"  \"";
if ($eventy !~ /\w+/) {
    print " SELECTED"
}
print ">\n";

for ($i=0; $i <=99; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d");
    if ($d eq $eventy) {
        print " SELECTED";
    }
    print (">$d\n");
}

print <<EOF
</SELECT>
Month:
<SELECT NAME=eventm>
EOF
;

print "<OPTION VALUE=\"  \"";
if ($eventm !~ /\w+/) {
    print " SELECTED"
}
print ">\n";

for ($i=0; $i <=11; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d");
    if ($d eq $eventm) {
        print " SELECTED";
    }
    print (">$month{$d}\n");
}

print <<EOF
</SELECT>
Day:
<SELECT NAME=eventd>
EOF
;

print "<OPTION VALUE=\"  \"";
if ($eventd !~ /\w+/) {
    print " SELECTED"
}
print ">\n";

for ($i=1; $i <=31; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d");
    if ($d eq $eventd) {
        print " SELECTED";
    }
    print (">$d\n");
}

print <<EOF
</SELECT>
</TD></TR>
<TR><TD ALIGN=RIGHT VALIGN=TOP>
Where:</TD><TD ALIGN=LEFT VALIGN=TOP><INPUT TYPE=TEXT NAME=where VALUE="$where"></TD></TR>
<TR><TD ALIGN=RIGHT VALIGN=TOP>
Ref:</TD><TD ALIGN=LEFT VALIGN=TOP><INPUT TYPE=TEXT NAME=ref VALUE="$ref">
</TD></TR>
<TR><TD ALIGN=RIGHT VALIGN=TOP>
Comment:</TD><TD ALIGN=LEFT VALIGN=TOP><TEXTAREA NAME=comment COLS=40 ROWS=3>$comment</TEXTAREA>
</TD></TR>
</TABLE>

EOF
;


print <<EOF
<P>
<CENTER>
<INPUT TYPE=SUBMIT VALUE=Submit><INPUT TYPE=RESET>
<BR><BR>
<INPUT TYPE=BUTTON VALUE="Cancel" ONCLICK="top.location.href='showperson.pl?user=$_user&tree=$_tree&nick=$_nick&familyname=$_familyname'">
<BR><BR>
<INPUT TYPE=BUTTON VALUE="Delete this event" ONCLICK=\'checkdel(\"$_key\");\'>
</FORM>
</CENTER>
</TD></TR>
</TABLE>
</BODY>
</HTML>
EOF
;

