#!/usr/bin/perl

use CGI qw(:standard escapeHTML);
use FTUtility;
use Colour;
use Date;
use EventDB;
use ParentsDB;
use PeopleDB;


use integer;

$_user=param ('user');
$_tree=param ('tree');
$_nick=param ('nick');
$_familyname=param ('familyname');


@people = PeopleDB::allPeopleDetails ($_user, $_tree);

$refbirth = EventDB::eventDate ($_tree, $_nick, "B");
$refdeath = EventDB::eventDate ($_tree, $_nick, "D");

PERSON: foreach $pr (@people) {
    $n = $pr->[0];
    $nm = $pr->[1];
    $s = $pr->[2];

    if ($_nick =~ /$n/) {
        $name = $nm;
        $sex = $s;
        next PERSON;
    }

    $b = EventDB::eventDate ($_tree, $n, "B");
    $d = EventDB::eventDate ($_tree, $n, "D");

    if (Date::aGTb ($b, $refbirth) ||
        Date::aLTb ($refdeath, $b) ||
        Date::aLTb ($d, $refbirth)) {
         next PERSON;
    }

    if ($s eq 'M') {
        $men{$n} = $nm;
    } else {
        $women{$n} = $nm;
    }
}


print <<EOF
Content-type: text/html

<HTML>
<HEAD><TITLE>Set parents</TITLE>
</HEAD><BODY BGCOLOR=$Colour::WindowBack>
EOF
;


print <<EOF
<TABLE BGCOLOR=#F0F0F0 BORDER=1 WIDTH=100%>
<TR><TD BGCOLOR=$Colour::HeaderBack>
<CENTER>
<H3>Parents for: $name ($sex)</H3>
EOF
;

($mother, $father) = ParentsDB::parents ($_user, $_tree, $_nick);

$b = EventDB::eventDate ($_tree, $_nick, "B");
print Date::format($b)." - ";
$d = EventDB::eventDate ($_tree, $_nick, "D");
print Date::format($d);

print <<EOF
</CENTER>
</TD></TR>
<TR><TD BGCOLOR=$Colour::DataBack>
EOF
;

$refdate = EventDB::eventDate ($_tree, $_nick, "B");
if ($refdate =~ /^\d\d\d\d/) {
    $refdateset = 1;
} else {
    $refdateset = 0;
}

print <<EOF
<CENTER>
EOF
;
print "<FORM METHOD=GET ACTION=setparents.pl>\n";
print "<INPUT TYPE=HIDDEN NAME=user VALUE=$_user>\n";
print "<INPUT TYPE=HIDDEN NAME=tree VALUE=$_tree>\n";
print "<INPUT TYPE=HIDDEN NAME=nick VALUE=$_nick>\n";
print "<INPUT TYPE=HIDDEN NAME=familyname VALUE=$_familyname>\n";

print "Mother: <SELECT NAME=mother>\n<OPTION>\n";
foreach $n (sort {$women{$a} cmp $women{$b}} keys %women) {
    $b = EventDB::eventDate ($_tree, $n, "B");
    $d = EventDB::eventDate ($_tree, $n, "D");

    if ($d =~ /^\d\d\d\d/) {
        $deathdateset = 1;
    } else {
        $deathdateset = 0;
    }

    if (!$refdateset || ((!$deathdateset || $d ge $refdate) && $b lt $refdate)) {
        if ($mother =~ /^$n$/) {
            print ("<OPTION VALUE=$n SELECTED>$women{$n} ($n) ");
        } else {
            print ("<OPTION VALUE=$n>$women{$n} ($n) ");
        }
        print " " . Date::formatYYYY ($b) . "\n";
    }
}
print "</SELECT>\n<BR>";

print "Father: <SELECT NAME=father>\n<OPTION>\n";
foreach $n (sort {$men{$a} cmp $men{$b}} keys %men) {
    $b = EventDB::eventDate ($_tree, $n, "B");
    $d = EventDB::eventDate ($_tree, $n, "D");

    if ($d =~ /^\d\d\d\d/) {
        $deathdateset = 1;
    } else {
        $deathdateset = 0;
    }

    if (!$refdateset || ((!$deathdateset || $d ge $refdate) && $b lt $refdate)) {
        if ($father =~ /^$n$/) {
            print "<OPTION VALUE=$n SELECTED>$men{$n} ($n) ";
        } else {
            print "<OPTION VALUE=$n>$men{$n} ($n) ";
        }
        print " " . Date::formatYYYY ($b) . "\n";
    }
}
print "</SELECT>\n";


print <<EOF
<P>
<INPUT TYPE=SUBMIT VALUE=Submit><INPUT TYPE=RESET>
<BR><BR>
<INPUT TYPE=BUTTON VALUE="Cancel" ONCLICK="top.location.href='showperson.pl?user=$_user&tree=$_tree&nick=$_nick&familyname=$_familyname'">
</FORM>
</CENTER>
</TD></TR>
EOF
;

print <<EOF
</TABLE>
</BODY>
</HTML>
EOF
;

