#!/usr/bin/perl

use CGI qw(:standard escapeHTML);
use Security;
use FTUtility;
use TreesDB;
use Date;
use EventDB;
use PeopleDB;


use integer;

$_user=param ('user');
$_tree=param ('tree');
$_familyname=param ('familyname');
$_searchtree=param ('searchtree');
$_searchtreeset=($_searchtree =~ /\w+/);
$_search=param ('search');
$_searchset=($_search =~ /\w+/);
$_eventtype=param ('eventtype');
$_eventtypeset=($_eventtype =~ /\w+/);
$_afterc=param ('afterc');
$_aftery=param ('aftery');
$_afterm=param ('afterm');
$_afterd=param ('afterd');
$_after=$_afterc . $_aftery . $_afterm . $_afterd;
$_afterset=($_after =~ /\w+/);
$_beforec=param ('beforec');
$_beforey=param ('beforey');
$_beforem=param ('beforem');
$_befored=param ('befored');
$_before=$_beforec . $_beforey . $_beforem . $_befored;
$_beforeset=($_before =~ /\w+/);
$_personstatus=param('personstatus');
$_atc=param ('atc');
$_aty=param ('aty');
$_atm=param ('atm');
$_atd=param ('atd');
$_at=$_atc . $_aty . $_atm . $_atd;
$_atset=($_at =~ /\w+/);
$_nolinks=param ('nolinks');
$_nolinksflag=$_nolinks eq "N";

$eventsearch = $_eventtypeset || $_afterset || $_beforeset;
$personsearch = $_searchset || $_atset || $_personstatus =~/\w+/;

if (!$eventsearch && !$personsearch) {
    $_searchtree = $_tree;
} elsif ($_searchtreeset) {
    @searchTrees = ($_searchtree);
} else {
    @searchTrees = TreesDB::allTrees ($_user);
}


$editmode=Security::editmode ($_user, $_tree);


$month{"00"}="Jan";
$month{"01"}="Feb";
$month{"02"}="Mar";
$month{"03"}="Apr";
$month{"04"}="May";
$month{"05"}="Jun";
$month{"06"}="Jul";
$month{"07"}="Aug";
$month{"08"}="Sep";
$month{"09"}="Oct";
$month{"10"}="Nov";
$month{"11"}="Dec";


print <<EOF
Content-type: text/html

<HTML>
<HEAD><TITLE>Search for persons and events</TITLE>
EOF
;

FTUtility::navScripts;

print <<EOF
</HEAD><BODY BGCOLOR=$Colour::WindowBack>
<TABLE BORDER=1 WIDTH=100%>
<TR><TD BGCOLOR=$Colour::HeaderBack COLSPAN=2>
<CENTER>
<H3>Search for persons and events</H3>
</CENTER>
</TD></TR>
<TR><TD VALIGN=TOP HEIGHT=100%>
EOF
;


FTUtility::navPanel ("search", $_user, $_tree, $_familyname);

print <<EOF
</TD><TD BGCOLOR=$Colour::DataBack>

<FORM METHOD=get ACTION=searchperson.pl>
<INPUT TYPE=HIDDEN NAME=user VALUE=$_user>
<INPUT TYPE=HIDDEN NAME=tree VALUE=$_tree>
<INPUT TYPE=HIDDEN NAME=familyname VALUE=$_familyname>
<INPUT TYPE=HIDDEN NAME=nolinks VALUE=$_nolinks>
<TABLE>
<TR><TD>Family Tree:</TD><TD><SELECT NAME=searchtree>\n
EOF
;

print ("<OPTION VALUE=\"\"");
if ($_searchtree !~ /\w+/) {
    print (" SELECTED");
}
print (">All trees\n");

open (TREES, "<./trees.idx");
while (<TREES>) {
    chomp;
    ($t, $tn) = split (/\|/);
    print ("<OPTION VALUE=\"$t\"");
    if ($_searchtree eq $t) {
        print (" SELECTED");
    }
    print (">$tn\n");
}    
close (TREES);

print <<EOF
</SELECT>
</TD></TR>
<TR><TD>Name pattern:</TD><TD><INPUT TYPE=TEXT NAME=search VALUE=\"$_search\"></TD></TR>
<TR><TD>Event: </TD><TD><SELECT NAME=eventtype>\n";
EOF
;

print ("<OPTION VALUE=\"\"");
if ($_eventtype !~ /\w+/) {
    print (" SELECTED");
}
print (">\n");

@et = EventDB::eventTypes ($_user, $_tree);

foreach $e (@et) {
    $code=$e->[0];
    $text=$e->[1];

    print ("<OPTION VALUE=$code");
    if ($_eventtype eq $code) {
        print (" SELECTED");
    }
    print (">$text\n");
}

print <<EOF
</SELECT>
</TD></TR>
<TR><TD>After:</TD><TD>
Century:
<SELECT NAME=afterc>
EOF
;
print "<OPTION VALUE=\"  \"";
if ($_afterc !~ /\w+/) {
    print " SELECTED"
}
print ">\n";


for ($i=14; $i <=20; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d");
    if ($d eq $_afterc) {
        print " SELECTED";
    }
    print (">$d\n");
}
print <<EOF
</SELECT>
Year:
<SELECT NAME=aftery>
EOF
;


print "<OPTION VALUE=\"  \"";
if ($_aftery !~ /\w+/) {
    print " SELECTED"
}
print ">\n";

for ($i=0; $i <=99; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d");
    if ($d eq $_aftery) {
        print " SELECTED";
    }
    print (">$d\n");
}

print <<EOF
</SELECT>
Month:
<SELECT NAME=afterm>
EOF
;

print "<OPTION VALUE=\"  \"";
if ($_afterm !~ /\w+/) {
    print " SELECTED"
}
print ">\n";

for ($i=0; $i <=11; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d");
    if ($d eq $_afterm) {
        print " SELECTED";
    }
    print (">$month{$d}\n");
}

print <<EOF
</SELECT>
Day:
<SELECT NAME=afterd>
EOF
;

print "<OPTION VALUE=\"  \"";
if ($_afterd !~ /\w+/) {
    print " SELECTED"
}
print ">\n";

for ($i=1; $i <=31; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d");
    if ($d eq $_afterd) {
        print " SELECTED";
    }
    print (">$d\n");
}

print <<EOF
</SELECT>
<TR><TD>Before:</TD><TD>
Century:
<SELECT NAME=beforec>
EOF
;
print "<OPTION VALUE=\"  \"";
if ($_beforec !~ /\w+/) {
    print " SELECTED"
}
print ">\n";


for ($i=14; $i <=20; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d");
    if ($d eq $_beforec) {
        print " SELECTED";
    }
    print (">$d\n");
}
print <<EOF
</SELECT>
Year:
<SELECT NAME=beforey>
EOF
;


print "<OPTION VALUE=\"  \"";
if ($_beforey !~ /\w+/) {
    print " SELECTED"
}
print ">\n";

for ($i=0; $i <=99; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d");
    if ($d eq $_beforey) {
        print " SELECTED";
    }
    print (">$d\n");
}

print <<EOF
</SELECT>
Month:
<SELECT NAME=beforem>
EOF
;

print "<OPTION VALUE=\"  \"";
if ($_beforem !~ /\w+/) {
    print " SELECTED"
}
print ">\n";

for ($i=0; $i <=11; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d");
    if ($d eq $_beforem) {
        print " SELECTED";
    }
    print (">$month{$d}\n");
}

print <<EOF
</SELECT>
Day:
<SELECT NAME=befored>
EOF
;

print "<OPTION VALUE=\"  \"";
if ($_befored !~ /\w+/) {
    print " SELECTED"
}
print ">\n";

for ($i=1; $i <=31; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d");
    if ($d eq $_befored) {
        print " SELECTED";
    }
    print (">$d\n");
}


print <<EOF
</SELECT>
<TR><TD>
Status:
</TD><TD>
<SELECT NAME=personstatus>
EOF
;

print ("<OPTION VALUE=\"\"");
if ($_personstatus !~ /\w+/) {
    print (" SELECTED");
}
print (">\n");

print ("<OPTION VALUE=U");
if ($_personstatus eq 'U') {
    print (" SELECTED");
}
print (">Unborn\n");

print ("<OPTION VALUE=L");
if ($_personstatus eq 'L') {
    print (" SELECTED");
}
print (">Living\n");

print ("<OPTION VALUE=D");
if ($_personstatus eq 'D') {
    print (" SELECTED");
}
print (">Dead\n");


print <<EOF
</SELECT>
<TR><TD>At:</TD><TD>
Century:
<SELECT NAME=atc>
EOF
;
print "<OPTION VALUE=\"  \"";
if ($_atc !~ /\w+/) {
    print " SELECTED"
}
print ">\n";


for ($i=14; $i <=20; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d");
    if ($d eq $_atc) {
        print " SELECTED";
    }
    print (">$d\n");
}
print <<EOF
</SELECT>
Year:
<SELECT NAME=aty>
EOF
;


print "<OPTION VALUE=\"  \"";
if ($_aty !~ /\w+/) {
    print " SELECTED"
}
print ">\n";

for ($i=0; $i <=99; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d");
    if ($d eq $_aty) {
        print " SELECTED";
    }
    print (">$d\n");
}

print <<EOF
</SELECT>
Month:
<SELECT NAME=atm>
EOF
;

print "<OPTION VALUE=\"  \"";
if ($_atm !~ /\w+/) {
    print " SELECTED"
}
print ">\n";

for ($i=0; $i <=11; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d");
    if ($d eq $_atm) {
        print " SELECTED";
    }
    print (">$month{$d}\n");
}

print <<EOF
</SELECT>
Day:
<SELECT NAME=atd>
EOF
;

print "<OPTION VALUE=\"  \"";
if ($_atd !~ /\w+/) {
    print " SELECTED"
}
print ">\n";

for ($i=1; $i <=31; $i++) {
    $d = $i;
    if ($i < 10) {
        $d = "0$d";
    }
    print ("<OPTION VALUE=$d");
    if ($d eq $_atd) {
        print " SELECTED";
    }
    print (">$d\n");
}


print <<EOF
</SELECT>
</TABLE>
<CENTER>
<INPUT TYPE=SUBMIT NAME=button VALUE=Submit> <INPUT TYPE=RESET><BR>
</CENTER>
</FORM>
</CENTER>
EOF
;


if ($eventsearch || $personsearch)
{

    foreach $thisTree (@searchTrees) {
        @eventlist = EventDB::allEventDetails ($thisTree);
        foreach (@eventlist) {
            $e = $_;
            chomp $e;
            ($key, $n, $type, $date, my $p1, my $p2, my $w, my $t) = split (/\|/, $e);
            $fullkey = LinksDB::fullyResolve ($t, $n);

            if ($type eq 'B') {
                $birth{$fullkey} = $date;
            }
            if ($type eq 'D') {
                $death{$fullkey} = $date;
            }

            if ($eventsearch) {
                if ((!$_eventtypeset || $type =~ /$_eventtype/) &&
                    (!$_afterset || $date ge $_after) &&
                    (!$_beforeset || $date le $_before)) {
                    $resultevents{"$key.$t"} = [($key, $fullkey, $type, $date, $w, LinksDB::fullyResolve ($t, $p1), LinksDB::fullyResolve ($t, $p2))];
                    $personhasevent{$fullkey} = 1;
                }
            }
        }

        if ($personsearch) {
            @people = PeopleDB::allPeopleDetails ($_user, $thisTree);

            PERSON: foreach $pr (@people) {
                $key = $pr->[0];
                $name = $pr->[1];
                $s = $pr->[2];
                $l = $pr->[3];
                $t = $pr->[4];

                $fullkey = LinksDB::fullyResolve ($t, $key);

                if ((!$eventsearch || $personhasevent{$fullkey}) && 
                    $name =~ /$_search/) {
                    $printperson{$fullkey} = $name;
                }
            }

            $aliasfound = 0;
            open( ALIASES, "<./trees/$thisTree/aliases.db" );
            while (<ALIASES>) {
                ($key, $name) = split (/\|/);
                $fullkey = LinksDB::fullyResolve ($thisTree, $key);
                if ((!$eventsearch || $personhasevent{$fullkey}) &&
                     $printperson{$fullkey} !~ /\w+/ &&
                     $name =~ /$_search/) {
                    foreach $aka (split (/\;/, $name)) {
                        if ($aka =~ /$_search/) {
                            $printperson{$fullkey} = $aka;
                            $aliasfound = 1;
                        }
                    }
                }
            }
            close (ALIASES);
    
        } else {
            @people = PeopleDB::allPeopleDetails ($_user, $thisTree);

            PERSON: foreach $pr (@people) {
                $key = $pr->[0];
                $name = $pr->[1];
                $s = $pr->[2];
                $l = $pr->[3];
                $t = $pr->[4];

                if (!$eventsearch || $personhasevent{"$t.$key"}) {
                    $fullkey = LinksDB::fullyResolve ($t, $key);
                    $printperson{$fullkey} = $name;
                }
            }
        }
    
        if ($_atset && $_personstatus =~ /\w+/) {
            foreach $key (keys printperson) {
                if ($_personstatus eq 'U' && 
                    ($birth{$key} !~ /\w+/ || $_at gt $birth{$key})) {
                    delete $printperson{$key};
                } elsif ($_personstatus eq 'D' && 
                         ($death{$key} !~ /\w+/ || $_at lt $death{$key})) {
                    delete $printperson{$key};
                } elsif ($_personstatus eq 'L' && 
                         (($death{$key} =~ /\w+/ && $_at gt $death{$key}) ||
                         ($birth{$key} =~ /\w+/ && $_at lt $birth{$key}))) {
                    delete $printperson{$key};
                }
            }
        }
    }
        
    print "<TABLE>\n";
    $n = 0;
    if ($eventsearch) {
        foreach $e (@et) {
            $code= $e->[0];
            $person1= $e->[1];
            $person2= $e->[2];
            $person3= $e->[3];
            $singular= $e->[4];
            $howmany= $e->[5];
            $mutual= $e->[6];
            $etext{$code} = [($person2, $singular, $howmany, $mutual)];
        }

        foreach $re (sort {$resultevents{$a}->[3] cmp $resultevents{$b}->[3]} (keys %resultevents)) {
            $key = $resultevents{$re}->[0];
            $nk = $resultevents{$re}->[1];
            $type = $resultevents{$re}->[2];
            $date = $resultevents{$re}->[3];
            $place = $resultevents{$re}->[4];
            $p1 = $resultevents{$re}->[5];
            $p2 = $resultevents{$re}->[6];

            $name = $printperson{$nk};

            if ($name =~ /\w+/) {
                $n++;
                print "<TR><TD VALIGN=TOP ALIGN=LEFT>";

                print Date::format ($date) ."</TD><TD VALIGN=TOP ALIGN=LEFT>";

                ($text, $prep) = split (/\|/, $etext{$type}->[0]);

                print $text;

                print " <A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$nk TARGET=FT_DATA>$name</A>";

                if ($prep =~ /\w+/) {
                    print " $prep";
                }

                $p1name = PeopleDB::fullName ($_user, $_tree, $p1);
                $p2name = PeopleDB::fullName ($_user, $_tree, $p2);

                if ($p1name =~ /\w+/) {
                    print " <A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$p1&familyname=$_familyname TARGET=FT_DATA>$p1name</A>";

                    if ($p2name =~ /\w+/) {
                        print " and <A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$p2&familyname=$_familyname TARGET=FT_DATA>$p2name</A>";
                    }
                }

                if ($place =~ /\w+/) {
                    print " $place";
                }



                print "</TD></TR>\n";
            }
        }
    } else {
        foreach $key (sort {$printperson{$a} cmp $printperson{$b}} keys printperson) {
            $name = $printperson{$key};
            $n++;
            if ($_nolinksflag) {
                print "<TR><TD>$name ($key)";
            } else {
                print "<TR><TD><A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$key TARGET=FT_DATA>$name</A>";
            }

            $b = $birth{$key};
            print " " . Date::formatYYYY($b)." - ";

            $d = $death{$key};
            print Date::formatYYYY($d)."</TD></TR>";
        }
    }
    print "</TABLE>\n";

    print "$n matches found\n";
}

print <<EOF
</TD></TR>
</TABLE>
</BODY>
</HTML>
EOF
;

