#!/usr/bin/perl

use CGI qw(:standard escapeHTML);
use Security;
use FTUtility;
use AliasesDB;
use Colour;
use Date;
use EventDB;
use PeopleDB;
use TreesDB;

use integer;


$_user=param ('user');
$_tree=param ('tree');
$_familyname=param ('familyname');

$editmode=Security::editmode ($_user, $_tree);

$treename = TreesDB::treeName ($_user, $_tree);


my $esn = 0;

@events = EventDB::eventDetailsFor ($_tree);
foreach (@events) {
    $k = $_[0];
    $n = $_->[1];
    $type = $_->[2];
    $date = $_->[3];
    $where = $_->[4];
    $p1 = $_->[5];
    $p2 = $_->[6];
    $tr = $_->[7];
    $er = $_->[8];
    $ec = $_->[9];

    if (! $event{"$date.$p1.$n.$type"}) {
        $event{"$date.$n.$p1.$type"} = "$k|$n|$type|$date|$p1|$p2|$where|$tr|$er|$ec";
        $esn++;
    }
}

print <<EOF
Content-type: text/html

<HTML>
<HEAD>
<TITLE>$treename History</TITLE>
EOF
;

FTUtility::navScripts;

print <<EOF
</HEAD>
<BODY BGCOLOR=$Colour::WindowBack>
EOF
;


print <<EOF
<TABLE BORDER=1 WIDTH=100%>
<TR><TD COLSPAN=2 BGCOLOR=$Colour::HeaderBack>
<CENTER><H3>$treename History</H3>
</TD></TR>
<TR><TD VALIGN=TOP WIDTH=150>
EOF
;

FTUtility::navPanel ("showhistory", $_user, $_tree, $_familyname);

print <<EOF
</TD>
<TD BGCOLOR=$Colour::ListBack ROWSPAN=2>
<TABLE>
EOF
;

@et = EventDB::eventTypes ($_user, $_tree);

foreach $e (@et) {
    $code= $e->[0];
    $person1= $e->[1];
    $person2= $e->[2];
    $person3= $e->[3];
    $singular= $e->[4];
    $howmany= $e->[5];
    $mutual= $e->[6];
    $etext{$code} = [($person1, $person2, $person3, $singular, $howmany, $mutual)];
}


EVENT: foreach $e (sort keys %event) {

    ($key, $n, $type, $date, $p1, $p2, $where, $t, $er, $ec) = split (/\|/, $event{$e});

    print "<TR><TD VALIGN=TOP>";

    print Date::format($date);

    print "</TD><TD VALIGN=TOP ALIGN=LEFT>\n";

    $name = PeopleDB::fullName ($_user, $_tree, $n);
    $p1name = PeopleDB::fullName ($_user, $_tree, $p1);
    $p2name = PeopleDB::fullName ($_user, $_tree, $p2);

    ($text, $prep) = split (/\|/, $etext{$type}->[1]);

    print "$text <A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$n&familyname=$_familyname TARGET=FT_DATA>$name</A> ";
    if ($prep =~ /\w+/) {
        print "$prep ";
    }

    if ($p1name =~ /\w+/) {
        print " <A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$p1&familyname=$_familyname TARGET=FT_DATA>$p1name</A>";

        if ($p2name =~ /\w+/) {
            print " and <A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$p2&familyname=$_familyname TARGET=FT_DATA>$p2name</A>";
        }
    }
 
    if ($where =~ /\w+/) {
        print " $where";
    }

    if ($er =~ /\w+/ || $ec =~ /\w+/) {
        print "<BR><I>";
        if ($er =~ /\w+/) {
            print "[$er] ";
        }
        if ($ec =~ /\w+/) {
            print $ec;
        }
        print "</I>";
    }

    print "</TD></TR>\n";
}

print "</TABLE>\n";

print <<EOF
</TABLE>
</BODY>
</HTML>
EOF
;

