#!/usr/bin/perl

use CGI qw(:standard escapeHTML);
use Security;
use AliasesDB;
use Colour;
use Date;
use EventDB;
use ParentsDB;
use PeopleDB;
use TreesDB;

use integer;


$_user=param ('user');
$_tree=param ('tree');
$_nick=param ('nick');
$_familyname=param ('familyname');

$_nick = LinksDB::resolve ($_tree, $_nick);

if ($_nick =~ /\w+\.\w+/) {
    ($_tree, $_nick) = split (/\./, $_nick);
}

$editmode=Security::editmode ($_user, $_tree);

my $esn = 0; # Event sequence no.

($n, $name, $sex, $homepage, $thistree, $comment, $link) = PeopleDB::personDetails ($_user, $_tree, $_nick);

$editmodeThisPerson=Security::editmode ($_user, $thistree);

$treename = TreesDB::treeName ($_user, $thistree);

$mother = "";
$father = "";

($mother, $father) = ParentsDB::parents ($_user, $_tree, $_nick);
@children = ParentsDB::children ($_user, $_tree, $_nick);

@siblings1 = ParentsDB::children ($_user, $_tree, $mother);
@siblings2 = ParentsDB::children ($_user, $_tree, $father);

foreach $s (@siblings1) {
    $siblings{$s} = 1 unless ($s eq $_nick);
}
foreach $s (@siblings2) {
    $siblings{$s} = 1 unless ($s eq $_nick);
}

@events = EventDB::eventDetailsFor ($_tree, $_nick);
foreach (@events) {
    $k = $_->[0];
    $n = $_->[1];
    $type = $_->[2];
    $date = $_->[3];
    $where = $_->[4];
    $p1 = $_->[5];
    $p2 = $_->[6];
    $tr = $_->[7];
    $er = $_->[8];
    $ec = $_->[9];

    if (PeopleDB::areSame ($_tree, $_nick, $n)) {
        if ($type eq 'D') {
            $keydate = Date::forceLatest ($date);
        } else {
            $keydate = $date;
        }

        $event{"$keydate.$type.$n.$esn"} = "$k|$n|$type|$date|$p1|$p2|$where|$tr|$er|$ec";
        $esn++;
    }

    if ($type eq "A" && (PeopleDB::areSame ($_tree, $p1, $_nick) || PeopleDB::areSame ($_tree, $p2, $_nick))) {
        $adoptees{$n} = 1;;
        $event{"$date.A+.$n.$esn"} = "$k|$n|A+|$date|$p1|$p2|$where|$tr|$er|$ec";
        $esn++;
    }

    if ($type eq "B") {
        $birth{$n} = $date;
    }
    if ($type eq "D") {
        $death{$n} = $date;
    }
    if ($type eq "M") {
        if (!PeopleDB::areSame ($_tree, $p1, $_nick)) {
            $lover{LinksDB::resolve ($_tree, $p1)} = 1;
        }
    }
}

if ($#children >= 0) {
    foreach $k (sort @children) {
        ($m, $f) = ParentsDB::parents ($_user, $_tree, $k);
        if (PeopleDB::areSame ($_tree, $m, $_nick)) {
            $p = LinksDB::resolve ($_tree, $f);
            $lover{$p} = 1;
            push @{$childrenby{$p}}, $k;
        } else {
            $p = LinksDB::resolve ($_tree, $m);
            $lover{$p} = 1;
            push @{$childrenby{$p}}, $k;
        }
    }
}

if ($mother =~ /\w+/) {
    ($n, $mothersname) = PeopleDB::personDetails ($_user, $_tree, $mother);
    ($d, $w, $p1, $p2, $r, $c) = EventDB::eventDetails ($_tree, $mother, 'D');
    if ($d =~ /\w+/) {
        $event{"$d.D+.$mother.$esn"} = "|$mother|D+|$d|$p1|$p2|$w|$_tree|$r|$c";
        $esn++;
    }
}
if ($father =~ /\w+/) {
    ($n, $fathersname) = PeopleDB::personDetails ($_user, $_tree, $father);
    ($d, $w, $p1, $p2, $r, $c) = EventDB::eventDetails ($_tree, $father, 'D');
    if ($d =~ /\w+/) {
        $event{"$d.D+.$father.$esn"} = "|$father|D+|$d|$p1|$p2|$w|$_tree|$r|$c";
        $esn++;
    }
}

print <<EOF
Content-type: text/html

<HTML>
<HEAD>
<SCRIPT LANGUAGE=JAVASCRIPT>
window.focus (self);
</SCRIPT>

<TITLE>$name</TITLE>
EOF
;

if ($editmode) {
    print <<EOF
<SCRIPT LANGUAGE=JAVASCRIPT>
function checkdelperson ()
{
    if (confirm ("Delete this person (" + "$_nick" + ")?"))
       top.location.href='delperson.pl?tree=$_tree&user=$_user&nick=$_nick';
}
</SCRIPT>
EOF
;
}

print <<EOF
</HEAD>
<BODY BGCOLOR=$Colour::WindowBack>
EOF
;


print <<EOF
<TABLE BORDER=1 WIDTH=100%>
<TR><TD COLSPAN=2 BGCOLOR=$Colour::HeaderBack>
<CENTER><H3>$name ($_nick) ($sex)</H3>
EOF
;

$date = $birth{$_nick};
print Date::format ($date) ." - ";
$date = $death{$_nick};
print Date::format ($date);

print <<EOF
</CENTER>
</TD></TR>
<TR>
EOF
;

$ancestors =  ($mother =~ /\w+/ || $father =~ /\w+/);
$descendants = ($#children >=0);

if ($ancestors || $descendants || $editmodeThisPerson) {
    print <<EOF
<TD BGCOLOR=$Colour::MenuBack VALIGN=TOP WIDTH=10 HEIGHT=100%>
<TABLE BGCOLOR=$Colour::MenuItemBack WIDTH=100%>
EOF
;


    $showsep = 0;

    if ($ancestors) {
        print "<TR><TD>\n";
        print "<A HREF=ancestors.pl?tree=$_tree&user=$_user&nick=$_nick&familyname=$_familyname TARGET=FT_NAV>View Ancestors</A><BR>\n";
        print "</TD></TR>\n";
        $showsep = 1;
    }

    if ($descendants) {
        print "<TR><TD>\n";
        print "<A HREF=descendants.pl?tree=$_tree&user=$_user&nick=$_nick&familyname=$_familyname TARGET=FT_NAV>View Descendants</A><BR>\n";
        print "</TD></TR>\n";
        $showsep = 1;
    }

    if ($showsep) {
        print "<TR><TD BGCOLOR=$Colour::MenuBack>&nbsp;</TD></TR>\n";
    }

    if ($editmodeThisPerson) {
        print <<EOF
<TR><TD>
<A HREF=modpersonform.pl?tree=$_tree&user=$_user&nick=$_nick TARGET=FT_DATA>Modify basic details</A>
</TD></TR>
<TR><TD>
<A HREF=parentform.pl?tree=$_tree&user=$_user&nick=$_nick&familyname=$_familyname TARGET=FT_DATA>Set parents</A><BR>
</TD></TR>
<TR><TD>
<A HREF=eventform.pl?tree=$_tree&user=$_user&nick=$_nick&familyname=$_familyname TARGET=FT_DATA>Add an event</A><BR>
</TD></TR>
<TR><TD BGCOLOR=$Colour::MenuBack>&nbsp;</TD></TR>
<TR><TD BGCOLOR=$Colour::MenuBack>&nbsp;</TD></TR>
<TR><TD BGCOLOR=$Colour::MenuBack ALIGN=CENTER VALIGN=MIDDLE>
<FORM><INPUT TYPE=BUTTON ONCLICK='checkdelperson()' VALUE='Delete this person'</FORM><BR>
</TD></TR>
EOF
;
    }

    print <<EOF
</TABLE>
</TD>
EOF
;
}

print <<EOF
<TD BGCOLOR=$Colour::DataBack ROWSPAN=2>
EOF
;

if ($comment =~ /\w+/) {
    print "$comment<BR><BR>\n";
}
if ($homepage =~ /\w+/) {
    print ("Home Page: <A HREF=\"$homepage\">$homepage</A><BR>\n");
    $needExtraBreak = 1;
}
if ($link =~ /\w+/) {
    print ("Further Info: <A HREF=\"$link\">$link</A><BR>\n");
    $needExtraBreak = 1;
}

if ($needExtraBreak) {
    print "<BR>\n";
}

print <<EOF
Mother: <A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$mother&familyname=$_familyname TARGET=FT_DATA>$mothersname</A><BR>
Father: <A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$father&familyname=$_familyname TARGET=FT_DATA>$fathersname</A><BR>
<BR>
EOF
;

if (!defined %siblings) {
    print "No Siblings<BR><BR>\n";
} else {
    print "Siblings:<UL>";
    my %sd;
    foreach $s (keys %siblings) {
        ($n, $name) = PeopleDB::personDetails ($_user, $_tree, $s);
        my $birth = EventDB::eventDate ($_tree, $s, 'B');
        my $death = EventDB::eventDate ($_tree, $s, 'D');
        $sd{$s}{name}=$name;
        $sd{$s}{birth}=$birth;
        $sd{$s}{death}=$death;
    }
    foreach $s (sort {$sd{$a}{birth} cmp $sd{$b}{birth}} keys %sd) {
        print "<LI><A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$s&familyname=$_familyname TARGET=FT_DATA>$sd{$s}{name}</A> ";
        print Date::format ($sd{$s}{birth})."-";
        print Date::format ($sd{$s}{death});
        print "\n";
    }

    print "</UL>\n";
}

if (defined %lover) {
    print "Known Partners:<UL>";
    foreach $k (keys lover) {
        ($n, $name) = PeopleDB::personDetails ($_user, $_tree, $k);
        print "<LI><A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$k&familyname=$_familyname TARGET=FT_DATA>$name</A> ";
        $date = EventDB::eventDate ($_tree, $k, 'B');
        print Date::format ($date)."-";
        $date = EventDB::eventDate ($_tree, $k, 'D');
        print Date::format ($date);

        ($d, $w, $p1, $p2, $r, $c) = EventDB::eventDetails ($_tree, $k, 'D');
        if ($d =~ /\w+/) {
            $event{"$d.D+.$k.$esn"} = "|$k|D+|$d|$p1|$p2|$w||$r|$c";
            $esn++;
        }
    }

    print "</UL>\n";
}

if ($#children >= 0) {
    foreach $p (keys %childrenby) {
        ($n, $name) = PeopleDB::personDetails ($_user, $_tree, $p);

        print "Children with <A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$p&famlyname=$_familyname TARGET=FT_DATA>$name</A>:<UL>\n";

        @kids = @{$childrenby{$p}};
        my %sd;
        foreach $k (sort @kids) {
            ($n, $childsname) = PeopleDB::personDetails ($_user, $_tree, $k);
            my $birth = EventDB::eventDate ($_tree, $k, 'B');
            my $death = EventDB::eventDate ($_tree, $k, 'D');
            $sd{$k}{name}=$childsname;
            $sd{$k}{birth}=$birth;
            $sd{$k}{death}=$death;

            ($d, $w, $p1, $p2, $r, $c) = EventDB::eventDetails ($_tree, $k, 'B');
            if ($d =~ /\w+/) {
                $event{"$d.B+.$k.$esn"} = "|$k|B+|$d|$p1|$p2|$w||$r|$c";
                $esn++;
            }
            ($d, $w, $p1, $p2, $r, $c) = EventDB::eventDetails ($_tree, $k, 'D');
            if ($d =~ /\w+/) {
                $event{"$d.D+.$k.$esn"} = "|$k|D+|$d|$p1|$p2|$w||$r|$c";
                $esn++;
            }
        }
        foreach $s (sort {$sd{$a}{birth} cmp $sd{$b}{birth}} keys %sd) {
            print "<LI><A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$s&familyname=$_familyname TARGET=FT_DATA>$sd{$s}{name}</A> ";
            print Date::format ($sd{$s}{birth})."-";
            print Date::format ($sd{$s}{death});
            print "\n";
        }
        print "</UL>\n";
    }

} else {
    print "No Children<BR><BR>\n";
}

if (defined (%adoptees)) {
    print "Adoptees:<UL>";
    foreach $k (keys %adoptees) {
        ($n, $childsname) = PeopleDB::personDetails ($_user, $_tree, $k);
        print "<LI><A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$k&familyname=$_familyname TARGET=FT_DATA>$childsname</A> ";
        $date = EventDB::eventDate ($_tree, $k, 'D');
        print Date::format($date)." - ";
        $date = EventDB::eventDate ($_tree, $k, 'D');
        print Date::format($date);

        ($d, $w, $p1, $p2, $r, $c) = EventDB::eventDetails ($_tree, $k, 'B');
        if ($d =~ /\w+/) {
            $event{"$d.B+.$k.$esn"} = "|$k|B+|$d|$p1|$p2|$w||$r|$c";
            $esn++;
        }
        ($d, $w, $p1, $p2, $r, $c) = EventDB::eventDetails ($_tree, $k, 'D');
        if ($d =~ /\w+/) {
            $event{"$d.D+.$k.$esn"} = "|$k|D+|$d|$p1|$p2|$w||$r|$c";
            $esn++;
        }

        print "\n";
    }

    print "</UL>\n";
}

if ($editmodeThisPerson) {
    print "<FORM ACTION=dummy METHOD=GET>\n";
}

print "<DL>\n";

@et = EventDB::eventTypes ($_user, $_tree);

foreach $e (@et) {
    $code= $e->[0];
    $person1= $e->[1];
    $person2= $e->[2];
    $person3= $e->[3];
    $singular= $e->[4];
    $howmany= $e->[5];
    $mutual= $e->[6];
    $etext{$code} = [($person1, $person2, $person3, $singular, $howmany, $mutual)];
}

EVENT: foreach $e (sort keys %event) {

    print "<DT>";
    ($key, $n, $type, $date, $p1, $p2, $where, $t, $er, $ec) = split (/\|/, $event{$e});

    if ($editmodeThisPerson && $_tree eq $t && $_nick eq $n) {
        print "<INPUT TYPE=BUTTON VALUE=Mod onClick=\"top.location.href='modeventform.pl?tree=$_tree&user=$_user&nick=$_nick&key='+escape(\'$key\');\">";
    }

    print Date::format ($date);

    $name = PeopleDB::fullName ($_user, $_tree, $n);
    $p1name = PeopleDB::fullName ($_user, $_tree, $p1);
    $p2name = PeopleDB::fullName ($_user, $_tree, $p2);

    ($code, $supp) = split (//, $type);

    print ' ';

    if ($supp eq '+') {
        print $etext{$code}->[2];
        print " <A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$n&familyname=$_familyname TARGET=FT_DATA>$name</A>";
    } else {
        print $etext{$code}->[0];

        if ($p1name =~ /\w+/) {
            print " <A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$p1&familyname=$_familyname TARGET=FT_DATA>$p1name</A>";

            if ($p2name =~ /\w+/) {
                print " and <A HREF=showperson.pl?tree=$_tree&user=$_user&nick=$p2&familyname=$_familyname TARGET=FT_DATA>$p2name</A>";
            }
        }
    }

    print " $where<BR>";

    if ($type eq 'D') {
        last EVENT;
    }

    if ($er =~ /\w+/ || $ec =~ /\w+/) {
        print "<DD>";
        if ($er =~ /\w+/) {
            print "[$er] ";
        }
        if ($ec =~ /\w+/) {
            print "$ec";
        }
    }
}

print "</DL>\n";

if ($editmodeThisPerson) {
    print "</FORM>\n";
}

@alias = AliasesDB::aliases ($_user, $_tree, $_nick);
foreach $a (@alias) {
    if ($a =~ /\w+/) {
        print "Also known as: $a<BR>\n";
    }
}

print <<EOF
<BR>
Family Tree : <A HREF=listall.pl?user=$_user&tree=$thistree TARGET=FT_NAV>$treename</A>
</TD></TR>
EOF
;

print <<EOF
</TABLE>
</BODY>
</HTML>
EOF
;

